/******************************************************************************
;  *   	@MCU				 : MA51F8203
;  *   	@Create Date         : 2020.01.02
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			         PWM1⣬úʹã²Ҫ޸                            		
******************************************************************************/

#include "PWM1_LIB.h"

void PWM1_StructInit(PWM1_InitTypeDef *PWM1InitStr)
{
	PWM1InitStr->PWM1_FB_polarity           = PWM1_FB_POL_UP;
	PWM1InitStr->PWM1_FB_OE                 = PWM1_FB_OE_DISABLE;
	PWM1InitStr->PWM1_out_cmp_chx           = 0x00U;
	PWM1InitStr->PWM1_clock_source          = PWM1_CLK_FSYS;
	PWM1InitStr->PWM1_mode                  = 0x00U;
	PWM1InitStr->PWM1_clock_division        = 0x00U;
	PWM1InitStr->PWM1_auto_load             = 0x00U;
	PWM1InitStr->PWM1_deat_oe               = 0x00U;
	PWM1InitStr->PWM1_polarity              = 0x00U;
//	PWM1InitStr->t PWM1_cmp_chx             = 0x00U;
	PWM1InitStr->PWM1_interrupt             = 0x00U;
	PWM1InitStr->PWM1_interrupt_priority    = 0x00U;
	PWM1InitStr->PWM1_FB_interrupt          = 0x00U;
	PWM1InitStr->PWM1_FB_interrupt_priority = 0x00U;
	
}

/************************************************
;  *    @Function Name       : PWM1_Init
;  *    @Description         : ĬϴPWM1ENPWM1CB
;  *    @IN_Parameter      	 :  PWM1 ò
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_Init(PWM1_InitTypeDef *PWM1)
{
    SLK_SFR1(); //лSFR1

    PWM1IER = REG_CLR;
    PWM1CR0 = REG_CLR;
    PWM1CR1 = REG_CLR;
    PWM1CR2 = REG_CLR;
    PWM1CR3 = REG_CLR;

    PWM1CR0 |= PWM1->PWM1_out_cmp_chx;
    PWM1IER |= PWM1->PWM1_FB_polarity | PWM1->PWM1_FB_OE;
    PWM1CR1 |= PWM1->PWM1_clock_source | PWM1->PWM1_mode | PWM1->PWM1_clock_division;
    PWM1CR2 |= PWM1->PWM1_auto_load | PWM1->PWM1_deat_oe | PWM1->PWM1_polarity;
    PWM1CR3 |= PWM1_CB | PWM1->PWM1_out_cmp_chx;
	  PWM1CR0 |= PWM1_EN;
    if (PWM1->PWM1_interrupt == ENABLE) //ʹPWM1ж
    {
        IP1 &= ~PWM1_IE_ADDR;
        IPH1 &= ~PWM1_IE_ADDR; //жȼ
        IE1 |= PWM1_IE_ADDR;
        if (PWM1->PWM1_interrupt_priority == HIGH)
        {
            IP1 |= PWM1_IE_ADDR; //жȼ
        }
    }
    else
    {
        IE1 &= ~PWM1_IE_ADDR;
        IP1 &= ~PWM1_IE_ADDR;
        IPH1 &= ~PWM1_IE_ADDR; //жȼ
    }
    if (PWM1->PWM1_FB_interrupt == ENABLE) //ʹPWM1FBж
    {
        IP1 &= ~PWM1_FBIE_ADDR;
        IPH1 &= ~PWM1_FBIE_ADDR; //жȼ
        IE1 |= PWM1_FBIE_ADDR;
        if (PWM1->PWM1_FB_interrupt_priority == HIGH)
        {
            IP1 |= PWM1_FBIE_ADDR; //жȼ
        }
    }
    else
    {
        IE1 &= ~PWM1_FBIE_ADDR;
        IP1 &= ~PWM1_FBIE_ADDR;
        IPH1 &= ~PWM1_FBIE_ADDR; //жȼ
    }
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_Out_Bit_Set
;  *    @Description         : PWM1ʹ
;  *    @IN_Parameter        :
;  *    @Return parameter    :ENABLE,DISABLE
                            chx=1--ch0
                            chx=3--ch0,1
                            .......
;  ***********************************************/
void PWM1_Out_Bit_Set(uint8_t state, uint8_t chx)
{
    if (chx <= PWM1_OUT_CMP_MAX)
    {
        SLK_SFR1(); //лSFR1
        if (state == ENABLE)
            PWM1CR0 |= chx;
        else
            PWM1CR0 &= ~chx;
        SLK_SFR0(); //лSFR0
    }
}
/************************************************
;  *    @Function Name       : PWM1_T_Set
;  *    @Description         : 
;  *    @IN_Parameter        :16λ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_T_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM1PH = num >> 8;
    PWM1PL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_D0_Set
;  *    @Description         : ռձ
;  *    @IN_Parameter        : 16λռձ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_D0_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM10DH = num >> 8;
    PWM10DL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_D1_Set
;  *    @Description         : ռձ ģʽЧ
;  *    @IN_Parameter        : 16λռձ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_D1_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM11DH = num >> 8;
    PWM11DL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_D2_Set
;  *    @Description         : ռձ
;  *    @IN_Parameter        : 16λռձ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_D2_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM12DH = num >> 8;
    PWM12DL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_D3_Set
;  *    @Description         : ռձ ģʽЧ
;  *    @IN_Parameter        : 16λռձ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_D3_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM13DH = num >> 8;
    PWM13DL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_D4_Set
;  *    @Description         : ռձ 
;  *    @IN_Parameter        : 16λռձ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_D4_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM14DH = num >> 8;
    PWM14DL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_D5_Set
;  *    @Description         : ռձ ģʽЧ
;  *    @IN_Parameter        : 16λռձ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_D5_Set(uint16_t num)
{
    SLK_SFR1(); //лSFR1
    PWM15DH = num >> 8;
    PWM15DL = num & 0x00ff;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_Deat_Time_Set01
;  *    @Description         : 01
;  *    @IN_Parameter        : ʱ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_Deat_Time01_Set(uint8_t num)
{
    SLK_SFR1(); //лSFR1
    PWM101F = num;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_Deat_Time_Set23
;  *    @Description         : 23
;  *    @IN_Parameter        : ʱ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_Deat_Time23_Set(uint8_t num)
{
    SLK_SFR1(); //лSFR1
    PWM123F = num;
    SLK_SFR0(); //лSFR0
}
/************************************************
;  *    @Function Name       : PWM1_Deat_Time_Set45
;  *    @Description         : 45
;  *    @IN_Parameter        : ʱ
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_Deat_Time45_Set(uint8_t num)
{
    SLK_SFR1(); //лSFR1
    PWM145F = num;
    SLK_SFR0(); //лSFR0
}

/**************************** end of file *********************************************/
